package sun.rmi.rmic;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.text.MessageFormat;
import java.util.MissingResourceException;
import java.util.Properties;
import java.util.ResourceBundle;
import sun.tools.java.ClassPath;

public class BatchEnvironment extends sun.tools.javac.BatchEnvironment {
   boolean propsLoaded = false;
   private static ResourceBundle resources;

   public BatchEnvironment(ClassPath var1) {
      super(var1);
   }

   public BatchEnvironment(OutputStream var1, ClassPath var2) {
      super(var1, var2);
   }

   public String getProperty(String var1) {
      if (!this.propsLoaded) {
         String var2 = System.getProperty("java.home");
         String var3 = System.getProperty("rmi.home");
         if (var3 == null || var3.length() == 0) {
            var3 = var2;
         }

         try {
            resources = ResourceBundle.getBundle("sun.tools.javac.resources.javac");
         } catch (MissingResourceException var5) {
            throw new Error("Fatal: Resource for javac is missing");
         }

         this.pushPropFile(var3, "rmic.properties");
         this.propsLoaded = true;
      }

      String var6;
      try {
         var6 = resources.getString(var1);
      } catch (MissingResourceException var4) {
         var6 = System.getProperty(var1);
      }

      return var6;
   }

   void pushPropFile(String var1, String var2) {
      String var3 = var1 + System.getProperty("file.separator") + "lib" + System.getProperty("file.separator") + var2;

      try {
         Properties var4 = new Properties(System.getProperties());
         BufferedInputStream var5 = new BufferedInputStream(new FileInputStream(var3));
         var4.load(var5);
         ((InputStream)var5).close();
         System.setProperties(var4);
      } catch (IOException var6) {
         ((sun.tools.javac.BatchEnvironment)this).output("failed to read: " + var3);
         ((Throwable)var6).printStackTrace();
      }
   }

   public String errorString(String var1, Object var2, Object var3, Object var4) {
      String var5 = null;
      if (var1.startsWith("warn.")) {
         var5 = this.getProperty("javac." + var1);
      }

      if (var5 == null) {
         var5 = this.getProperty("javac.err." + var1);
      }

      if (var5 == null) {
         var5 = this.getProperty(var1);
      }

      if (var5 == null) {
         return "error message '" + var1 + "' not found";
      } else {
         Object[] var6 = new Object[]{var2, var3, var4};

         for(int var7 = 0; var7 < var6.length; ++var7) {
            if (var6[var7] != null & !(var6[var7] instanceof String)) {
               var6[var7] = var6[var7].toString();
            }
         }

         return MessageFormat.format(var5, var6);
      }
   }
}
