package sun.rmi.rmic;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;

public class ProxyStream extends PrintStream {
   private int currentIndent;
   private int indentStep;
   private boolean beginningOfLine;

   public ProxyStream(String var1) throws IOException {
      this((OutputStream)(new FileOutputStream(var1)));
   }

   public ProxyStream(OutputStream var1) {
      this(var1, false);
   }

   public ProxyStream(OutputStream var1, boolean var2) {
      this(var1, false, 4);
   }

   public ProxyStream(OutputStream var1, boolean var2, int var3) {
      super(var1, var2);
      this.currentIndent = 0;
      this.indentStep = var3;
   }

   public void write(int var1) {
      if (this.beginningOfLine) {
         this.pIndent();
      }

      super.write(var1);
      this.beginningOfLine = var1 == 10;
   }

   public void write(byte[] var1, int var2, int var3) {
      for(int var4 = 0; var4 < var3; ++var4) {
         this.write(var1[var2 + var4]);
      }

   }

   public void setIndent(int var1) {
      this.currentIndent = var1;
   }

   public int getIndent() {
      return this.currentIndent;
   }

   private void pIndent() {
      for(int var1 = 0; var1 < this.currentIndent; ++var1) {
         super.write(32);
      }

   }

   // $FF: renamed from: pI (java.lang.String) void
   public void method_0(String var1) {
      this.currentIndent += this.indentStep;
      ((PrintStream)this).print(var1);
   }

   // $FF: renamed from: pI () void
   public void method_1() {
      this.currentIndent += this.indentStep;
   }

   public void pIln(String var1) {
      this.currentIndent += this.indentStep;
      ((PrintStream)this).println(var1);
   }

   // $FF: renamed from: pO (java.lang.String) void
   public void method_2(String var1) {
      this.currentIndent -= this.indentStep;
      ((PrintStream)this).print(var1);
   }

   // $FF: renamed from: pO () void
   public void method_3() {
      this.currentIndent -= this.indentStep;
   }

   public void pOln(String var1) {
      this.currentIndent -= this.indentStep;
      ((PrintStream)this).println(var1);
   }

   // $FF: renamed from: p (java.lang.String) void
   public void method_4(String var1) {
      ((PrintStream)this).print(var1);
   }

   public void pln(String var1) {
      ((PrintStream)this).println(var1);
   }

   public void pln() {
      ((PrintStream)this).println();
   }
}
